[indent=4]

uses
    Gtk

/*----------------------------------------------------

  this files contains the CUSTOM tree related actions
  for our program.




------------------------------------------------------*/


//-- action: a line in tree1 was clicked --

def tree1_row_clicked() 

    //-- delete the filelist in the second tree --
    treeclass2.store.clear()
    
    var ret = treeclass1.foldertree_click(mytree1)
    if ret is ""
        return
    
    //print ("selected is: %s" , ret )
    treeclass1.current_path = ret
    
    //-- create a new filelist in the second tree --
    treeclass1.show_filelist( treeclass1.current_path , treeclass2)




//-- action: a line in tree2 was clicked --

//-- we load and show an image with this method --

def tree2_row_click() 

    var ret = treeclass2.tree_click(mytree2)
    //print ("selected is: %s" , ret)
    //print("%s" , treeclass1.current_path)
    
    if not ret.contains(".")
        return
    var suffix= ret.rchr(-1,'.').down()


        
    var load = false
    if suffix is ".jpg"
        load = true
    
    if suffix is ".jpeg"
        load = true
                
    if suffix is ".png"
        load = true   
        
    if suffix is ".bmp"
        load = true
        
    if suffix is ".gif"
        load = true   
         
    if suffix is ".xpm"
        load = true   
         
    if load is false
        return
        

    var scale = get_togglebutton("checkbutton1").get_active()

    if scale
        //-- calculate the size for the image --
        var wx=0
        var wy=0
        get_window("window1").get_size (out wx, out wy)
        //print("%d --- %d" , wx,wy)
    
    
        var p1 = get_paned("hpaned1").get_position ()
        var p2 = get_paned("hpaned2").get_position ()
    
        wx=wx-p1-p2-40
    
        //-- load to a pixbuf first, as this can be scaled --

        pixbuf : Gdk.Pixbuf
        try
            pixbuf= new Gdk.Pixbuf.from_file_at_size(treeclass1.current_path + "/" + ret , wx,wy-80)
        except ex : GLib.Error
            print("%s", "load pixbuf failed!")
    
        get_image("image1").set_from_pixbuf(pixbuf) 
        pixbuf=null

    else
        get_image("image1").set_from_file(treeclass1.current_path + "/" + ret) 


    current_file=treeclass1.current_path + "/" + ret
    



def tree3_row_click() 
    //print ("%s" , "bookmarks...")

    //-- this returns an index of the selected item in a un-expanded tree (like a list) --
    var a = treeclass3.get_selected_index(mytree3)
    print("%s" , bookmarkfolders[a])
    if not treeclass1.root_expanded 
        treeclass1.expand(treeclass1 , "0" )
    treeclass1.expand_filetree(treeclass1 , bookmarkfolders[a]  )
    tree1_row_clicked() 


def load_bookmarks(thetreeclass : treeclass)

    bookmarks = new array of string[300]
    bookmarkfolders = new array of string[300]
    
    var c=0

    //if not FileUtils.test("/root/.gtk-bookmarks--" ,FileTest.EXISTS  )
    //    return
        
    f:FileStream
    if (f = FileStream.open( Environment.get_home_dir() +  "/.gtk-bookmarks" , "r")) is not null

        var a = new array of char[10240]

        while f.gets(a) is not null

            var s = (string)a
            if s.contains("file://")
                var as = new array of string[2]
                
                if s.contains(" ")
                    as = s.split(" " , 2)
                else
                    as[0] = s
                    as[1] = Filename.display_basename(s)
                as[0].strip()
                as[1].strip()
                bookmarks[c] = as[1]
                bookmarkfolders[c] = as[0].replace("file://" , "")
                treeclass3.add_root_item(as[1] )
                c++


//-- action: a line in the tree1 was collapsed --

def tree1_row_collapsed(iter : TreeIter , path : TreePath)

    //-- update the filelist for the second tree --
    tree1_row_clicked() 


//-- action: a line in the tree2 was expanded --

def tree1_row_expanded(iter : TreeIter , path : TreePath)

    //-- update the filelist for the second tree --
    tree1_row_clicked()



//-- action: a line in the tree2 was expanded --

def tree2_row_expanded(iter : TreeIter , path : TreePath)


    //-- we do not need this in the picturebrowser --

    print ("%s" , "test 1")
    //var ret = ""
    //treeclass2.store.get(iter ,1 ,out ret)
    //print ("expanded: %s" , ret)    
    //print ("path: %s" , path.to_string()) 

//-- action: a line in the tree2 was collapsed --

def tree2_row_collapsed(iter : TreeIter , path : TreePath)

    //-- we do not need this in the picturebrowser --

    print ("%s" , "test 2")
    //var ret = ""
    //treeclass2.store.get(iter ,1 ,out ret)
    //print ("collapsed: %s" , ret)    
    //print ("path: %s" , path.to_string())





