[indent=4]

/*----------------------------------------------------

  this files contains the libglade related actions
  for our program.

  you must add here the methods, that return
  a widget like a button or a entry if required


------------------------------------------------------*/

uses
    Gtk

xml : Glade.XML

def libglade_init( args : array of string)
    Gtk.init (ref args)
    xml = new Glade.XML ("project.glade", null, null)
    xml.signal_autoconnect_full (connect_signals)



//-- HELPER method: this is needed for every program using libglade --

def connect_signals (handler_name : string, object : GLib.Object, signal_name : string ,signal_data : string? , connect_object : GLib.Object?, after : bool)
    var module = Module.open (null, ModuleFlags.BIND_LAZY)
    sym : void*

    if (module.symbol (handler_name, out sym))
        Signal.connect (object, signal_name, (GLib.Callback) sym, null)


//-- HELPER method: this method returns a WIDGET ! --
//-- it finds a widget object managed by libglade using the name of the widget --

def get_widget(name : string) : Widget
    var w = xml.get_widget(name)
    return w


//-- HELPER method: this method returns a SCROLLEDWINDOW ! --

def get_scrolledwindow(name : string) : ScrolledWindow
    b : Gtk.ScrolledWindow*
    var w = xml.get_widget(name)
    b = (ScrolledWindow) w
    return b


//-- HELPER method: this method returns a WINDOW ! --

def get_window(name : string) : Window
    b : Window*
    var w = xml.get_widget(name)
    b = (Window) w
    return b


//-- HELPER method: this method returns a PANED ! --

def get_paned(name : string) : Paned
    b : Paned*
    var w = xml.get_widget(name)
    b = (Paned) w
    return b
    

//-- HELPER method: this method returns a BOX ! --

def get_box(name : string) : Box
    b : Box*
    var w = xml.get_widget(name)
    b = (Box) w
    return b
    
//-- HELPER method: this method returns a IMAGE ! --

def get_image(name : string) : Image
    b : Image*
    var w = xml.get_widget(name)
    b = (Image) w
    return b  

//-- HELPER method: this method returns a TOGGLEBUTTON ! --

def get_togglebutton(name : string) : ToggleButton
    b : ToggleButton*
    var w = xml.get_widget(name)
    b = (ToggleButton) w
    return b 

//------------------------------------------------- ACTION
def on_window1_destroy (widget : Widget)

  //-- exit program when window is closed --
  
    Gtk.main_quit ()


def on_eventbox1_button_release_event (widget : EventBox, eventbutton : Gdk.EventButton)
    
    
    //-- cycle through a list of pictures with the mousebuttons --
    
    var button = (int) eventbutton.button
    //print("%s , %d" , "eventbox" , button)

    if button is 1
        var iter = treeclass2.get_selected_iter(mytree2)
        if treeclass2.store.iter_is_valid(iter)
            var nextiter = treeclass2.get_next_iter(mytree2, iter)
            treeclass2.select_iter(treeclass2, nextiter)
            
            tree2_row_click() 
            return

    if button is 3
        var iter = treeclass2.get_selected_iter(mytree2)
        if treeclass2.store.iter_is_valid(iter)
            var previousiter = treeclass2.get_previous_iter(mytree2, iter)
            treeclass2.select_iter(treeclass2, previousiter)
            tree2_row_click() 



def refresh_thread():int

    //-- this reloads the image scaled wiith a delay, when the window is resized --

    Thread.usleep(500000)
    refreshpause = false

    Gdk.threads_enter()
    tree2_row_click()
    Gdk.threads_leave()

    return 0
 
def on_window1_size_request(widget : Window)


    //-- if window resizes...
    //.. rescale the displayed image...

    if not get_togglebutton("checkbutton1").get_active()
        return

    if refreshpause is true
        return
        
    try
        Thread.create( (ThreadFunc)refresh_thread, false)
    except ex : GLib.ThreadError
        print ("%s" , "threaderror!")
        
    refreshpause = true
    


